<?php

namespace Ardent\PipelineBundle\Pipeline\OptionsProcessor;

class OptionsProcessor
{
    private Options $options;

    public function __construct(
        ?Options $options = null,
    )
    {
        $this->options = $options ?? new Options([]);
    }

    public function process(ItemBag $items, OptionsStageInterface ...$stages): ItemBag
    {
        foreach ($stages as $stage) {
            $stage->setOptions($this->options);

            $stage->before($items);
            foreach ($items->all() as $item) {
                $newItems = $stage($item);

                if ($item->isDelete()) {
                    $items->remove($item);
                }

                foreach ($newItems as $newItem) {
                    $items->add($newItem);
                }
            }
            $stage->after($items);
        }

        return $items;
    }
}