<?php

namespace Ardent\PipelineBundle\Pipeline\OptionsProcessor;

use Exception;

class SubItemStage extends AbstractOptionsStage
{
    private ?ItemBagPipeline $subPipeline = null;

    public function getSubPipeline(): ItemBagPipeline
    {
        if (!$this->subPipeline) {
            throw new Exception('subPipeline not set');
        }
        return $this->subPipeline;
    }

    public function setSubPipeline(ItemBagPipeline $subPipeline): self
    {
        $clone = clone $this;
        $clone->subPipeline = $subPipeline;
        return $clone;
    }

    public function __invoke(Item $item): array
    {
        $this->getSubPipeline()->process($item->getChildren());

        return [];
    }
}